<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
        <a-col :span="24">
          <a-form-item label="页面抓取id" v-bind="validateInfos.linkPageId">
            <JSelectLinkPageSysSet v-model:value="formData.linkPageId" ></JSelectLinkPageSysSet>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="资源链接" v-bind="validateInfos.source">
            <a-input v-model:value="formData.source" placeholder="请输入资源链接" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="资源标题" v-bind="validateInfos.title">
            <a-input v-model:value="formData.title" placeholder="请输入资源标题" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="父地址类型" v-bind="validateInfos.typeSource">
            <a-input v-model:value="formData.typeSource" placeholder="请输入父地址类型" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="父地址状态" v-bind="validateInfos.stateSource">
            <a-input v-model:value="formData.stateSource" placeholder="请输入父地址状态" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="主站点链接" v-bind="validateInfos.mainUrl">
            <a-input v-model:value="formData.mainUrl" placeholder="请输入主站点链接" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="错敏词列表" v-bind="validateInfos.sensitiveList">
	          <a-textarea v-model:value="formData.sensitiveList" rows="4" placeholder="请输入错敏词列表" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="校对敏感词个数" v-bind="validateInfos.sensitiveCount">
	          <a-input-number v-model:value="formData.sensitiveCount" placeholder="请输入校对敏感词个数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="成功标记" v-bind="validateInfos.retCode">
	          <a-input-number v-model:value="formData.retCode" placeholder="请输入成功标记" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="校对错误个数" v-bind="validateInfos.errorCount">
	          <a-input-number v-model:value="formData.errorCount" placeholder="请输入校对错误个数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="校对重点关注词个数" v-bind="validateInfos.heavyCount">
	          <a-input-number v-model:value="formData.heavyCount" placeholder="请输入校对重点关注词个数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="修改状态" v-bind="validateInfos.modifyState">
            <j-dict-select-tag type='radio' v-model:value="formData.modifyState" dictCode="modify_state" placeholder="请选择修改状态" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="文章发布时间" v-bind="validateInfos.articleReleaseTime">
		        <a-date-picker placeholder="请选择文章发布时间" v-model:value="formData.articleReleaseTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="扫描次数" v-bind="validateInfos.numberScans">
	          <a-input-number v-model:value="formData.numberScans" placeholder="请输入扫描次数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="是否忽略" v-bind="validateInfos.isIgnore">
            <j-dict-select-tag type='radio' v-model:value="formData.isIgnore" dictCode="verify_status" placeholder="请选择是否忽略" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核时间" v-bind="validateInfos.checkTime">
		        <a-date-picker placeholder="请选择复核时间" v-model:value="formData.checkTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核状态" v-bind="validateInfos.checkState">
            <j-dict-select-tag type='radio' v-model:value="formData.checkState" dictCode="verify_status" placeholder="请选择复核状态" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核校对错误个数" v-bind="validateInfos.checkErrorCount">
	          <a-input-number v-model:value="formData.checkErrorCount" placeholder="请输入复核校对错误个数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../LinkCaptureErrorLog.api';
  import { Form } from 'ant-design-vue';
  import JSelectLinkPageSysSet from '/@/components/Form/src/jeecg/components/JSelectLinkPageSysSet.vue';
  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    linkPageId: '',
    source: '',
    title: '',
    typeSource: '',
    stateSource: '',
    mainUrl: '',
    sensitiveList: '',
    sensitiveCount: undefined,
    retCode: undefined,
    errorCount: undefined,
    heavyCount: undefined,
    modifyState: '',
    articleReleaseTime: '',
    numberScans: undefined,
    isIgnore: '',
    checkTime: '',
    checkState: '',
    checkErrorCount: undefined,
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
    linkPageId: [{ required: true, message: '请输入页面抓取id!'},],
    source: [{ required: true, message: '请输入资源链接!'},],
    typeSource: [{ required: true, message: '请输入父地址类型!'},],
    stateSource: [{ required: true, message: '请输入父地址状态!'},],
    mainUrl: [{ required: true, message: '请输入主站点链接!'},],
    sensitiveList: [{ required: true, message: '请输入错敏词列表!'},],
    sensitiveCount: [{ required: true, message: '请输入校对敏感词个数!'},],
    retCode: [{ required: true, message: '请输入成功标记!'},],
    errorCount: [{ required: true, message: '请输入校对错误个数!'},],
    heavyCount: [{ required: true, message: '请输入校对重点关注词个数!'},],
    modifyState: [{ required: true, message: '请输入修改状态!'},],
    isIgnore: [{ required: true, message: '请输入是否忽略!'},],
    checkState: [{ required: true, message: '请输入复核状态!'},],
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });


  /**
   * 新增
   */
  function add() {
    edit({});
    setTimeout(function() {
      var mainSite = localStorage.getItem("main_site");
      if(mainSite != null){
        try {
          var objMainSite = JSON.parse(mainSite);
          if(objMainSite.mainSiteUrl != null && objMainSite.mainSiteUrl != ""){
            formData.mainUrl = objMainSite.mainSiteUrl
          }
        }catch (err){
          formData.mainUrl = null
        }
      }else {
        formData.mainUrl = null
      }
    }, 500); // 定时时间
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 24px 24px 24px 24px;
  }
</style>
